module convert.

kind    tm      type.

type    abs     (tm -> tm) -> tm.
type    app     tm -> tm -> tm.

type    redex   tm -> tm -> o.
type    red1    tm -> tm -> o.
type    conv    tm -> tm -> o.

redex (app (abs M) N)  (M N).                        % beta
redex (abs X\(app M X)) M.                           % eta

red1 M N :- redex M N.
red1 (abs M) (abs N) :- pi X\ (red1 (M X) (N X)).    % xi
red1 (app M N) (app P N) :- red1 M P.                % cong1   
red1 (app M N) (app M P) :- red1 N P.                % cong2

conv M N :- red1 M P.                                % red
conv M M.                                            % refl
conv M N :- conv N M.                                % sym
conv M N :- conv M P, conv P N.                      % trans
