% This module is the main prover for an automatic theorem prover for
% a sequent system for first-order classical logic.

module lc_prove.

import  lprf lists.

kind    seq     type.

type    -->     (list form) -> (list form) -> seq.
type    >-2     lprf -> seq -> o.

infix   -->     4.
infix   >-2     3.

(initial A) >-2 (Gamma --> Delta) :- memb A Gamma, memb A Delta.

(and_l Q) >-2 (Gamma --> Delta) :-
  memb_and_rest (A and B) Gamma Gamma1, Q >-2 ((A::B::Gamma1) --> Delta).

(imp_r Q) >-2 (Gamma --> Delta) :-
  memb_and_rest (A imp B) Delta Delta1, Q >-2 ((A::Gamma) --> (B::Delta1)).

(exists_l Q) >-2 (Gamma --> Delta) :-
  memb_and_rest (exists A) Gamma Gamma1,
  pi T \ ((Q T) >-2 (((A T)::Gamma1) --> Delta)).

(forall_r Q) >-2 (Gamma --> Delta) :-
  memb_and_rest (forall A) Delta Delta1,
  pi T \ ((Q T) >-2 (Gamma --> ((A T)::Delta1))).

(exists_r T Q) >-2 (Gamma --> Delta) :-
  memb_and_rest (exists A) Delta Delta1, Q >-2 (Gamma --> ((A T)::Delta1)).

(forall_l T Q) >-2 (Gamma --> Delta) :-
  memb_and_rest (forall A) Gamma Gamma1, Q >-2 (((A T)::Gamma1) --> Delta).

(or_l Q1 Q2) >-2 (Gamma --> Delta) :-
  memb_and_rest (A or B) Gamma Gamma1,
  Q1 >-2 ((A::Gamma1) --> Delta), Q2 >-2 ((B::Gamma1) --> Delta).

(and_r Q1 Q2) >-2 (Gamma --> Delta) :-
  memb_and_rest (A and B) Delta Delta1,
  Q1 >-2 (Gamma --> (A::Delta1)), Q2 >-2 (Gamma --> (B::Delta1)).

(imp_l Q1 Q2) >-2 (Gamma --> Delta) :-
  memb_and_rest (A imp B) Gamma Gamma1,
  Q1 >-2 (Gamma1 --> (A::Delta)), Q2 >-2 ((B::Gamma1) --> Delta).

(neg_r Q) >-2 (Gamma --> Delta) :-
  memb_and_rest (neg A) Delta Delta1, Q >-2 ((A::Gamma) --> Delta1).

(or_r Q) >-2 (Gamma --> Delta) :-
  memb_and_rest (A or B) Delta Delta1, Q >-2 (Gamma --> (A::B::Delta1)).

(neg_l Q) >-2 (Gamma --> Delta) :-
  memb_and_rest (neg A) Gamma Gamma1, Q >-2 (Gamma1 --> (A::Delta)).
