module lfnorm.

import lfconv.

type    normal_ki       ki -> o.
type    normal_ty       ty -> o.
type    normal_ty1      ty -> o.
type    normal_ty2      ty -> o.
type    normal_tm       tm -> o.
type    normal_tm1      tm -> o.
type    norm_ki         ki -> ki -> o.
type    norm_ty         ty -> ty -> o.
type    norm_tm         tm -> tm -> o.

normal_ki typ.
normal_ki (prod_ki K A) :- normal_ty A, pi X\ (normal_tm1 X => normal_ki (K X)).

normal_ty (abs_ty B A) :- normal_ty A, pi X\ (normal_tm1 X => normal_ty (B X)).
normal_ty A :- normal_ty1 A.

normal_ty1 (prod_ty B A) :- normal_ty A, pi X\ (normal_tm1 X => normal_ty1 (B X)).
normal_ty1 A :- normal_ty2 A.

normal_ty2 (app_ty A N) :- normal_ty2 A, normal_tm N.

normal_tm (abs_tm M A) :- normal_ty A, pi X\ (normal_tm1 X => normal_tm (M X)).
normal_tm M :- normal_tm1 M.

normal_tm1 (app_tm M N) :- normal_tm1 M, normal_tm N.

norm_tm M N :- conv_tm M N, normal_tm N.
norm_ty A B :- conv_ty A B, normal_ty B.
norm_ki K L :- conv_ki K L, normal_ki L.
